Redmine - Feature #10999

Ticket list filter: More flexible filter conditions
2012-05-23 10:14 - Frank Helk

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues filter Estimated time: 0.00 hour

Target version:

Resolution:

Description
| have not found any workaround on that by now ...

As far as | understand it, the filter conditions for the ticket list (text fields) filter on an exact phrase in any case. With that behaviour, |
can't filter for tickets containing i.e. 2 words at random positions in the field. Normally | would circumvent that by just adding another
filter on the same field, but unfortunately that is blocked - only one condition per field is allowed.

| would suggest to either

- allow multiple filter conditions on the same field, connected by "AND", or

- implement some kind of optional pattern search like RegEx, or

- (preferred) implement search pattern interpretation rules for text fields, like a choice of
"exact phrase / all words (AND) / any word (OR) / RegEx" as drop down list.

Related issues:

Related to Redmine - Feature #1140: Filtering using more than one instance of... New 2008-04-29
Related to Redmine - Feature #4939: List of tasks filtered as OR and not AND New 2010-02-26
Related to Redmine - Feature #13635: Filtering issues by comparing two custom... New

Has duplicate Redmine - Feature #23216: Issues List, Enhanced Filtering - All... Closed

History

#1 - 2012-09-14 13:39 - Daniel Albuschat
The first suggestion is related to #1140.

#2 - 2013-01-31 01:25 - peter longfield
+1 see also #6332

#3 - 2013-07-03 09:33 - Ralph Twele

+1

#4 - 2013-08-27 17:41 - Markus Garscha

+1

#5 - 2013-09-10 09:01 - Anekcen Jlowikapés

+1

#6 - 2014-04-24 07:24 - @ go2null

+1
Would also like to see it for (multi-select) lists:

any of (replaces is)

none of (replaces is not)

all of

not all of

is empty (replaces none)

is not empty (replaces any)
https://www.redmine.org/issues/1140
https://www.redmine.org/issues/6332

#7 - 2014-04-24 07:52 - @ go2null

Note: you can currently filter text fields thus:
field contains value1%value2

Obvious caveat: value1 must be before value2 in field.

#8 - 2014-05-23 13:18 - Toshi MARUYAMA
- Related to deleted (Feature #6332: "OR" filter and not only "AND" filter)

#9 - 2015-10-03 15:51 - txemi M
+1.

I would suggest allowing to bypass Ul filter limitations accepting a query expressed in query language.
With this, next goals would be achieved:

Not adding complexity to current user interface, no need to develop complex user interface to express complex queries.

e Easy to develop if query language matchs internal query ruby on rails languages (I am not a ruby developer, | am not sure how queries are
expressed internally, but if so, sure the patch to achieve this would be very small).

¢ Queries would not be limited to user interface, offering all features availables at backend.

¢ Any user with some development hability could express any query.

At front end option to use query language instead of current form should be offered to users.
Any ruby on rails developer could throw an opinion on this, is it feasible?

#10 - 2015-10-16 09:37 - Istvan Heckl
+13)

#11 - 2015-11-17 13:48 - Janis Elmeris

+1
#12 - 2016-03-06 08:17 - Hide MATSUTANI
+1
| think it's better if we could choose in the 'list' formatted custom fields.
@ go2null wrote:
+1
Would also like to see it for (multi-select) lists:
any of (replaces is)
none of (replaces is not)
all of
not all of

is empty (replaces none)
is not empty (replaces any)

#13 - 2016-06-27 16:34 - Jared Davenport

+1

#14 - 2016-07-01 03:09 - Toshi MARUYAMA

- Category changed from Ul to Issues filter

#15 - 2016-07-01 03:12 - Toshi MARUYAMA
- Has duplicate Feature #23216: Issues List, Enhanced Filtering - Allowing Multiple Queries & "OR"-type constraints added

#16 - 2016-07-08 12:27 - Anonymous

+1

#17 - 2016-07-22 12:52 - Jean Louis
+10
| don't find plugin that do this, | try _query plugin but it's between 2 different filters.
| want to search (any of) words in only issues description filter, for example: word1 OR word2

@ go2null wrote:
Would also like to see it for (multi-select) lists:

any of (replaces is)

none of (replaces is not)

all of

not all of

is empty (replaces none)

is not empty (replaces any)

#18 - 2016-07-23 04:36 - Quan VN

Dear Jean Louis

Thank you for your note. | see your point. For the list type fields, this is built-in as far as | understand. For text field in general, | will try to see if | can
implement something like your suggestion.

Quan

Jean Louis wrote:
+10

I don't find plugin that do this, | try _query plugin but it's between 2 different filters.
| want to search (any of) words in only issues description filter, for example: word1 OR word2

@ go2null wrote:
Would also like to see it for (multi-select) lists:

any of (replaces is)

none of (replaces is not)
all of

not all of

is empty (replaces none)

is not empty (replaces any)

#19 - 2016-07-24 09:32 - Quan VN

Update on July 24

Jean Lacoste Louis: Thank you again for your suggestion. | have implemented the two operators on the text field allowing to do boolean search within
a text field, so you can search something like:

(word1 OR word 2) AND word3 AND NOT word4.

Please help me to test it here. (it is updated version of _query)

http://www.redmine.org/plugins/boolean_query

Jean Louis wrote:
+10

| don't find plugin that do this, | try _query plugin but it's between 2 different filters.
| want to search (any of) words in only issues description filter, for example: word1 OR word2

@ go2null wrote:
Would also like to see it for (multi-select) lists:

any of (replaces is)

none of (replaces is not)
all of

not all of

is empty (replaces none)
is not empty (replaces any)
https://www.redmine.org/users/9013
http://www.redmine.org/plugins/boolean_query

#20 - 2016-11-09 09:00 - Andreas F

Any news about this topic? We need the possibility to use and/or conditions. Also we need the possibility to filter project tags ...
A must have :)

#21 - 2016-11-10 15:44 - Frank Helk

Doesn't ook like there are any news on this. I'm still waiting for it, with some constantly nagging users in my back :(

BTW: | don't think that this functionality is a candidate for a plugin ... it should definitely be part of the Redmine core package.

#22 - 2017-03-03 20:05 - Robert Mulvey

+1

#23 - 2017-03-10 14:32 - Anonymous

+1

#24 - 2017-05-12 10:23 - Susana Mielgo

+1

#25 - 2017-05-18 18:37 - Mike Kozhurin

+1

#26 - 2017-05-23 10:37 - Augustin de La Riviére

+1

#27 - 2017-05-23 11:07 - Frank Helk

Hmmm - | see constantly dripping in "+1" from people who would like to have that too, but the issue is active for 5 years now w/o anybody feeling the
urge to implement it.

Any hint how to draw a bit attention on this ?

#28 - 2017-07-13 09:15 - Abuzer N

+1 this is so needed

#29 - 2017-09-26 09:34 - Yu AOKI

@Quan VN

Thank you for boolean_query plugin.

When | tested it on redmine 3.1.0, I've got a NoMethodError on 'sql_contains', so | needed to modify line 175 on query_patch2.rb as follows:
(This is just FYI, since | am not exactly sure if 3.1.0 is under support, nor how | can contribute on this plugin, such as pull request.)

[before mod]
sgql << "(" + sgl_contains("#{db_table}.#{db_field}", term, match) + ")"

[after mod]
sgql << " (" + "LOWER (#{db_table}.#{db_field}) LIKE 'S$#{self.class.connection.quote_string(term.to_s.downcase) }

% ™ + " ) "
Thanks.
Quan VN wrote:
Update on July 24
Jean Lacoste Louis: Thank you again for your suggestion. | have implemented the two operators on the text field allowing to do boolean search
within a text field, so you can search something like:
(word1 OR word 2) AND word3 AND NOT word4.

Please help me to test it here. (it is updated version of _query)

http://www.redmine.org/plugins/boolean_query

Jean Louis wrote:

2025-07-04 4/5


https://www.redmine.org/users/9013
http://www.redmine.org/plugins/boolean_query

+10

| don't find plugin that do this, | try _query plugin but it's between 2 different filters.
| want to search (any of) words in only issues description filter, for example: word1 OR word2

@ go2null wrote:
Would also like to see it for (multi-select) lists:

any of (replaces is)

none of (replaces is not)
all of

not all of

is empty (replaces none)

is not empty (replaces any)

#30 - 2017-09-26 14:19 - Frank Helk

Just an additional opinion:

Creating some plugin is nice, but | presume that plugins are a measure for very special problems like interfacing to other software and tasks not close
to Redmine's core functionality. Unfortunately then features requested here affect (tune up ? dope ? ;-) a very core part of Redmine, and I'd prefer
them to be realized where they belong: In the core of Redmine.

Besides of that plugins tend to get unsupported with time moving on, and every new Redmine release bears the risk of breaking the plugin. | wouldn't
recommend to expose such a core-near feature to that vulnerability.

#31 - 2017-09-28 12:02 - Roman Yagodin

+1

Could not create a simple "Issues created or closed today" query without OR!

#32 - 2018-04-20 21:18 - name zero
+11}
